<template>
    <b-container>
        <!-- <b-button to="/">Home</b-button> -->
        <p>{{changeRec}}</p>
        <b-row class="mt=3">
          <!-- <b-col></b-col> -->
            <b-col>
                <b-form @submit="onSubmit" @reset="onReset" v-if="show" class="mt-1">
                    
                    <b-form-group
                        id="input-group-1" label-cols="4"
                        label="Email address:"
                        label-for="input-1" label-size="lg"
                        description="We'll never share your email with anyone else."
                    >
                        <b-form-input
                        id="input-1"
                        v-model="form.email"
                        type="email"
                        required size="sm"
                        placeholder="Enter email"
                        ></b-form-input>
                    </b-form-group>

                    <b-form-group id="input-group-2" label="Your Name:" label-for="input-2">
                        <b-form-input
                        id="input-2"
                        v-model="form.name"
                        required
                        placeholder="Enter name"
                        ></b-form-input>
                    </b-form-group>

                    <b-form-group id="input-group-3" label="Food:" label-for="input-3">
                        <b-form-select
                        id="input-3"
                        v-model="form.food"
                        :options="foods"
                        required
                        ></b-form-select>
                    </b-form-group>

                    <b-form-group id="input-group-4">
                        <b-form-checkbox-group v-model="form.checked" id="checkboxes-4">
                            <b-form-checkbox value="me">Check me out</b-form-checkbox>
                            <b-form-checkbox value="that">Check that out</b-form-checkbox>
                        </b-form-checkbox-group>
                    </b-form-group>
                    <b-alert variant="success" dismissible :show="showAlert">Data Saved!</b-alert>
                    <b-button type="submit" variant="success" class="mr-3">Submit</b-button>
                    <b-button type="reset" variant="outline-primary">Reset</b-button>
                </b-form>
            </b-col>
            <!-- <b-col></b-col> -->
        </b-row>   
        
    </b-container>
</template>

<script>
import * as _ from "lodash";

export default {
  props: ["name"],
  // watch: {
  //   name(newValue, oldValue) {
  //     if (newValue == "new") {
  //       this.form = {
  //         email: "",
  //         name: "",
  //         food: null,
  //         checked: [],
  //         gender: null

  //       };
  //     } else {
  //       if (localStorage.getItem("formData")) {
  //         this.form = JSON.parse(localStorage.getItem("formData"));
  //       }
  //     }
  //   }
  // },
  computed:{
    changeRec(){
      if (this.name == "new") {
        this.form = {
          email: "",
          name: "",
          food: null,
          checked: [],
          gender: null

        };
        return "This is New Record";
      } else {
        if (localStorage.getItem("formData")) {
          this.form = JSON.parse(localStorage.getItem("formData"));
        }
        return "Editing : " + this.name;
      }
      return this.name;
    }
  },
  data() {
    return {
      showAlert: false,
      form: {
        email: "",
        name: "",
        food: null,
        checked: [],
        gender: null
      },
      foods: [
        { text: "Select One", value: null },
        "Carrots",
        "Beans",
        "Tomatoes",
        "Corn"
      ],
      show: true
    };
  },
  methods: {
    goback(evt) {
      this.$router.push("/");
    },
    onSubmit(evt) {
      evt.preventDefault();
      //alert(JSON.stringify(this.form));
      var list = [];

      if (localStorage.getItem("formArray")) {
        list = JSON.parse(localStorage.getItem("formArray"));
      }

      if (this.name != "new") {
        var e = this.form.email;
        _.remove(list, function(listrec) {
          return listrec.email == e;
        });
      }

      list.push(this.form);
      localStorage.setItem("formArray", JSON.stringify(list));

      this.form = {
        email: "",
        name: "",
        food: null,
        checked: [],
        gender: null
      };

      this.showAlert = true;
      this.$emit("recChange");
    },
    onReset(evt) {
      evt.preventDefault();
      // Reset our form values
      this.form.email = "";
      this.form.name = "";
      this.form.food = null;
      this.form.checked = [];
      // Trick to reset/clear native browser form validation state
      this.show = false;
      this.$nextTick(() => {
        this.show = true;
      });
    }
  },
  mounted() {
    if (this.name != "new") {
      if (localStorage.getItem("formData")) {
        this.form = JSON.parse(localStorage.getItem("formData"));
      }
    } else {
      this.form = {
        email: "",
        name: "",
        food: null,
        checked: [],
        gender: null
      };
    }
  }
  //   created(){
  //       alert("Created");
  //   }
};
</script>

<style>
</style>
